<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.sasl-module.html">Package&nbsp;sasl</a> ::
        <a href="pyxmpp.sasl.digest_md5-module.html">Module&nbsp;digest_md5</a> ::
        Class&nbsp;DigestMD5ServerAuthenticator
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class DigestMD5ServerAuthenticator</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator">source&nbsp;code</a></span></p>
<pre class="base-tree">
<a href="pyxmpp.sasl.core.ServerAuthenticator-class.html">core.ServerAuthenticator</a> --+
                           |
                          <strong class="uidshort">DigestMD5ServerAuthenticator</strong>
</pre>

<hr />
Provides DIGEST-MD5 SASL authentication for a server.

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">password_manager</span>)</span><br />
      Initialize a <a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html" class="link">DigestMD5ServerAuthenticator</a> object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#start" class="summary-sig-name">start</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">response</span>)</span><br />
      Start the authentication process.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.start">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#response" class="summary-sig-name">response</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">response</span>)</span><br />
      Process a client reponse.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.response">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#_parse_response" class="summary-sig-name" onclick="show_private();">_parse_response</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">response</span>)</span><br />
      Parse a client reponse and pass to further processing.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._parse_response">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#_check_params" class="summary-sig-name" onclick="show_private();">_check_params</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">realm</span>,
        <span class="summary-sig-arg">cnonce</span>,
        <span class="summary-sig-arg">digest_uri</span>,
        <span class="summary-sig-arg">response_val</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">nonce_count</span>)</span><br />
      Check parameters of a client reponse and pass them to further
processing.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._check_params">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html#_make_final_challenge" class="summary-sig-name" onclick="show_private();">_make_final_challenge</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">realm</span>,
        <span class="summary-sig-arg">cnonce</span>,
        <span class="summary-sig-arg">digest_uri</span>,
        <span class="summary-sig-arg">response_val</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">nonce_count</span>)</span><br />
      Send the second challenge in reply to the client response.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._make_final_challenge">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">password_manager</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.__init__">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize a <a href="pyxmpp.sasl.digest_md5.DigestMD5ServerAuthenticator-class.html" class="link">DigestMD5ServerAuthenticator</a> object.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>password_manager</code></strong> (: <a href="pyxmpp.sasl.core.PasswordManager-class.html" class="link">PasswordManager</a>) - : name of the password manager object providing
authentication credential verification.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.ServerAuthenticator-class.html#__init__">core.ServerAuthenticator.__init__</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="start"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">start</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">response</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.start">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Start the authentication process.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>response</code></strong> (: <code class="link">str</code>) - : the initial response from the client (empty for
DIGEST-MD5).</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></dt>
        <dd>a challenge, a success indicator or a failure indicator.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.ServerAuthenticator-class.html#start">core.ServerAuthenticator.start</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="response"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">response</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">response</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator.response">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process a client reponse.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>response</code></strong> (: <code class="link">str</code>) - : the response from the client.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></dt>
        <dd>a challenge, a success indicator or a failure indicator.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.ServerAuthenticator-class.html#response">core.ServerAuthenticator.response</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_parse_response"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_parse_response</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">response</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._parse_response">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Parse a client reponse and pass to further processing.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>response</code></strong> (: <code class="link">str</code>) - : the response from the client.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></dt>
        <dd>a challenge, a success indicator or a failure indicator.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_check_params"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_check_params</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">username</span>,
        <span class="sig-arg">realm</span>,
        <span class="sig-arg">cnonce</span>,
        <span class="sig-arg">digest_uri</span>,
        <span class="sig-arg">response_val</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">nonce_count</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._check_params">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Check parameters of a client reponse and pass them to further
processing.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">str</code>) - : user name.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">str</code>) - : realm.</li>
        <li><strong class="pname"><code>cnonce</code></strong> (: <code class="link">str</code>) - : cnonce value.</li>
        <li><strong class="pname"><code>digest_uri</code></strong> (: <code class="link">str</code>) - : digest-uri value.</li>
        <li><strong class="pname"><code>response_val</code></strong> (: <code class="link">str</code>) - : response value computed by the client.</li>
        <li><strong class="pname"><code>authzid</code></strong> (: <code class="link">str</code>) - : authorization id.</li>
        <li><strong class="pname"><code>nonce_count</code></strong> (: <code class="link">int</code>) - : nonce count value.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></dt>
        <dd>a challenge, a success indicator or a failure indicator.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_make_final_challenge"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_make_final_challenge</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">username</span>,
        <span class="sig-arg">realm</span>,
        <span class="sig-arg">cnonce</span>,
        <span class="sig-arg">digest_uri</span>,
        <span class="sig-arg">response_val</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">nonce_count</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.sasl.digest_md5-pysrc.html#DigestMD5ServerAuthenticator._make_final_challenge">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Send the second challenge in reply to the client response.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">str</code>) - : user name.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">str</code>) - : realm.</li>
        <li><strong class="pname"><code>cnonce</code></strong> (: <code class="link">str</code>) - : cnonce value.</li>
        <li><strong class="pname"><code>digest_uri</code></strong> (: <code class="link">str</code>) - : digest-uri value.</li>
        <li><strong class="pname"><code>response_val</code></strong> (: <code class="link">str</code>) - : response value computed by the client.</li>
        <li><strong class="pname"><code>authzid</code></strong> (: <code class="link">str</code>) - : authorization id.</li>
        <li><strong class="pname"><code>nonce_count</code></strong> (: <code class="link">int</code>) - : nonce count value.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.sasl.core.Challenge-class.html" class="link">sasl.Challenge</a>, <a href="pyxmpp.sasl.core.Success-class.html" class="link">sasl.Success</a> or <a href="pyxmpp.sasl.core.Failure-class.html" class="link">sasl.Failure</a></dt>
        <dd>a challenge, a success indicator or a failure indicator.</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:04 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
